let timeOffset = 0;
let gotSyncSignal = false;

function tick() {
  const now = performance.now();
  const currentTimestamp = now + timeOffset;
  const data = new Uint8Array(8);
  const view = new DataView(data.buffer);
  view.setFloat64(0, currentTimestamp);
  realtime.send(data);

  if (currentTimestamp > 1000 || gotSyncSignal) {
    document.getElementById("timestamp").textContent = (currentTimestamp / 1000)
      .toFixed(1);
  }
}

function receiveUpdate(msg) {
  const now = performance.now();
  const view = new DataView(msg.buffer);
  const newTimestamp = view.getFloat64(0);
  const currentTimestamp = now + timeOffset;
  const newOffset = newTimestamp - currentTimestamp;
  if (newOffset > timeOffset) {
    timeOffset = newOffset;
  }
  gotSyncSignal = true;
}

setInterval(tick, 100);

const realtime = window.webxdc.joinRealtimeChannel();
realtime.setListener(receiveUpdate);
